image: docker:19.03.1
services:
  - docker:19.03.1-dind

stages:
- build
- deploy
- test

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_HOST: tcp://docker:2376 # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled

build:
  stage: build
  script:
  - docker pull ${CI_REGISTRY_IMAGE}:latest || true
  - docker build --cache-from ${CI_REGISTRY_IMAGE}:latest
                 --tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
                 --tag ${CI_REGISTRY_IMAGE}:latest .
  - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
  - docker push ${CI_REGISTRY_IMAGE}:latest
  only:
  - master
  before_script:
  - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}

pages:
  image:
    name: ${CI_REGISTRY_IMAGE}:latest
    entrypoint: [""]
  stage: deploy
  script:
  - pip3 install -r docs/source/requirements.txt
  - ~/.local/bin/sphinx-build -b html docs/source/ public
  artifacts:
    paths:
    - public
  only:
  - master

test:
  stage: test
  script:
  - mkdir out
  - chmod 777 out 
  - docker run --name examscan --rm -v $(pwd):$(pwd) -w $(pwd) ${CI_REGISTRY_IMAGE}:latest watermark.py tests/assets/pdfs out
  artifacts:
    paths:
    - out/

test-coverage:
  image: 
    name: ${CI_REGISTRY_IMAGE}:latest
    entrypoint: [""]
  stage: test
  script:
    - pip3 install pytest pytest-cov
    - cd /app
    - python3 -m pytest --cov=./ tests
    - python3 -m coverage xml -o reports/coverage.xml
  artifacts:
    paths:
      - reports/coverage.xml
    reports:
      cobertura: reports/coverage.xml

test-docs:
  image:
    name: ${CI_REGISTRY_IMAGE}:latest
    entrypoint: [""]
  stage: test
  script:
  - pip3 install -r docs/source/requirements.txt
  - ~/.local/bin/sphinx-build -b html docs/source/ public
  only:
  - branches
  except:
  - master
